Index: mppenc/branches/zorg/src/mppenc.c
===================================================================
--- mppenc/branches/zorg/src/mppenc.c	(revision 52)
+++ mppenc/branches/zorg/src/mppenc.c	(revision 54)
@@ -141,5 +141,5 @@
     stderr_printf (
              "\n"
-             "\033[1m\rusage:\033[0m\n"
+             "\033[1m\rUsage:\033[0m\n"
              "  mppenc [--options] <Input_File>\n"
              "  mppenc [--options] <Input_File> <Output_File>\n"
@@ -149,49 +149,61 @@
 
     stderr_printf (
-             "\033[1m\rInput_File must be:\033[0m\n"
-             "  -                for stdin (only RIFF WAVE files)\n"
-             "  /dev/audio       for soundcard (OSS only at the moment), 44.1 kHz\n"
+             "\033[1m\rInput_File must be of the following:\033[0m\n"
+             "  -                stdin                 (only RIFF WAVE files)\n"
+             "  /dev/audio       soundcard             (using OSS, 44.1 kHz)\n"
              "  *.wav            RIFF WAVE file\n"
-             "  *.raw/cdr        Raw PCM, 2 channels, 16 bit, 44.1 kHz, little endian\n"
-             "  *.pac/lpac       LPAC file                (needs LPAC 1.36+ for Windows)\n"
-             "  *.fla/flac       FLAC file                (needs FLAC 1.03+ for Windows)\n"
-             "  *.ape            Monkey's Audio APE file  (needs MAC 3.96b2...7)\n"
-             "  *.rka/rkau       RK Audio file            (offical binaries do not work)\n"
+             "  *.raw/cdr        Raw PCM               (2ch, 16bit, 44.1kHz)\n"
+             "  *.pac/lpac       LPAC file             (Windows Only)\n"
+             "  *.fla/flac       FLAC file\n"
+             "  *.ape            Monkey's Audio file   (APE extension only)\n"
+             "  *.rka/rkau       RK Audio file         (Windows Only)\n"
              "  *.sz             SZIP file\n"
-             "  *.shn            Shorten file             (needs Shorten 3.4+ for Windows)\n"
-             "  *.ofr            OptimFROG file\n"
+             "  *.shn            Shorten file\n"
+             "  *.wv             Wavpack File\n"
+             "  *.ofr            OptimFROG file        (Windows Only)\n"
              "\n"
-             "Currently only 32, 37.8, 44.1 and 48 kHz, 1...8 channels, 8...32 bit linear PCM\n"
-             "is supported. When using one of the lossless compressed formats, a proper binary\n"
-             "must be installed within the system's search path.\n"
+             "  Currently only 32, 37.8, 44.1 and 48 kHz, 1-8 channels, 8-32 bit linear PCM\n"
+             "  is supported. When using one of the lossless compressed formats, a proper\n"
+             "  binary must be installed within the system's $PATH.\n"
              "\n"
-             "\033[1m\rOutput_File must be (otherwise file name is generated from Input_File):\033[0m\n"
-             "  *.mpc            Musepack file name \n"
-             "  *.mp+/mpp        old extentions known as MPEGplus\n"
-             "  -                for stdout\n"
-             "  /dev/null        for trash can\n"
+             "\033[1m\rOutput_File must be of the following: (or generated from Input_File)\033[0m\n"
+             "  *.mpc            Musepack file\n"
+             "  *.mp+/mpp        MPEGplus file         (Deprecated)\n"
+             "  -                stdout\n"
+             "  /dev/null        trash can\n"
              "\n" );
 
     stderr_printf (
-             "\033[1m\rProfile Options (Quality Presets):\033[0m\n"
-             "  --telephone      lowest quality,       (typ.  32... 48 kbps)\n"
-             "  --thumb          low quality/internet, (typ.  58... 86 kbps)\n"
-             "  --radio          medium (MP3) quality, (typ. 112...152 kbps)\n"
-             "  --standard       high quality (dflt),  (typ. 142...184 kbps)\n"
-             "  --xtreme         extreme high quality, (typ. 168...212 kbps)\n"
-             "  --insane         extreme high quality, (typ. 232...268 kbps)\n"
-             "  --braindead      extreme high quality, (typ. 232...278 kbps)\n"
+             "\033[1m\rProfiles and Quality Scale:\033[0m\n"
+             "\n"
+             "  Option of using a profile (--radio) or mapped quality scale (--quality 4.0).\n"
+             "  In addition, quality scale is effective centesimally. (i.e. --quality 4.25)\n"
+             "  Available options are as follows:\n"
+             "\n"
+             "  below telephone  (--quality 0.00)   poor quality          (~  20 kbps)\n"
+             "  below telephone  (--quality 1.00)   poor quality          (~  30 kbps)\n"
+             "  --telephone      (--quality 2.00)   low quality           (~  60 kbps)\n"
+             "  --thumb          (--quality 3.00)   good quality          (~  90 kbps)\n"
+             "  --radio          (--quality 4.00)   great quality         (~ 130 kbps)\n"
+             "  --standard       (--quality 5.00)   high quality, (dflt)  (~ 180 kbps)\n"
+             "   (or --normal)\n"
+             "  --xtreme         (--quality 6.00)   excellent quality     (~ 210 kbps)\n"
+             "   (or --extreme)\n"
+             "  --insane         (--quality 7.00)   excellent quality     (~ 240 kbps)\n"
+             "  --braindead      (--quality 8.00)   excellent quality     (~ 270 kbps)\n"
+             "  above braindead  (--quality 9.00)   excellent quality     (~ 300 kbps)\n"
+             "  above braindead  (--quality 10.00)  excellent quality     (~ 350 kbps)\n"
              "\n" );
 
     stderr_printf (
              "\033[1m\rFile/Message handling:\033[0m\n"
-             "  --silent         do not write any message to the console\n"
-             "  --verbose        increase verbosity (dflt: off)\n"
+             "  --silent         repress console messages                 (dflt: off)\n"
+             "  --verbose        increase verbosity                       (dflt: off)\n"
              "  --longhelp       print this help text\n"
-             "  --stderr fn      append messages to file 'fn'\n"
-             "  --neveroverwrite never overwrite existing destination file\n"
-             "  --interactive    ask before overwrite existing destination file (dflt)\n"
-             "  --overwrite      overwrite existing destination file\n"
-             "  --deleteinput    delete input file after encoding (dflt: off)\n"
+             "  --stderr foo     append messages to file 'foo'\n"
+             "  --neveroverwrite never overwrite existing Output_File     (dflt: off)\n"
+             "  --interactive    ask to overwrite an existing Output_File (dflt: on)\n"
+             "  --overwrite      overwrite existing Output_File           (dflt: off)\n"
+             "  --deleteinput    delete Input_File after encoding         (dflt: off)\n"
              "\n" );
 
@@ -291,7 +303,7 @@
              "  mppenc inputfile.wav\n"
              "  mppenc inputfile.wav outputfile.mpc\n"
-             "  mppenc --xtreme inputfile.pac outputfile.mpc\n"
-             "  mppenc --silent --radio --pns 0.25 inputfile.pac outputfile.mpc\n"
-             "  mppenc --nmt 12 --tmn 28 inputfile.pac outputfile.mpc\n"
+             "  mppenc --radio inputfile.wav outputfile.mpc\n"
+             "  mppenc --silent --radio --pns 0.25 inputfile.wav outputfile.mpc\n"
+             "  mppenc --nmt 12 --tmn 28 inputfile.wav outputfile.mpc\n"
              "\n"
              "For further information see the file 'MANUAL.TXT'.\n" );
@@ -304,5 +316,5 @@
     stderr_printf (
              "\n"
-             "\033[1m\rusage:\033[0m\n"
+             "\033[1m\rUsage:\033[0m\n"
              "  mppenc [--options] <Input_File>\n"
              "  mppenc [--options] <Input_File> <Output_File>\n"
@@ -310,15 +322,15 @@
 
              "\033[1m\rStandard options:\033[0m\n"
-             "  --silent       do not write any message to the console (dflt: off)\n"
-             "  --deleteinput  delete input file after encoding        (dflt: off)\n"
-             "  --overwrite    overwrite existing destination file     (dflt: off)\n"
-             "  --fade sec     fade in and out with 'sec' duration     (dflt: 0.0)\n"
+             "  --silent         repress console messages                 (dflt: off)\n"
+             "  --verbose        increase verbosity                       (dflt: off)\n"
+             "  --deleteinput    delete Input_File after encoding         (dflt: off)\n"
+             "  --overwrite      overwrite existing Output_File           (dflt: off)\n"
              "\n"
 
-             "\033[1m\rProfile Options (Quality Presets):\033[0m\n"
-             "  --thumb        low quality/internet, (typ.  58... 86 kbps)\n"
-             "  --radio        medium (MP3) quality, (typ. 112...152 kbps)\n"
-             "  --standard     high quality (dflt),  (typ. 142...184 kbps)\n"
-             "  --xtreme       extreme high quality, (typ. 168...212 kbps)\n"
+             "\033[1m\rProfiles and Quality Scale:\033[0m\n"
+             "  --thumb          (--quality 3.00)   good quality          (~  90 kbps)\n"
+             "  --radio          (--quality 4.00)   great quality         (~ 130 kbps)\n"
+             "  --standard       (--quality 5.00)   high quality, (dflt)  (~ 180 kbps)\n"
+             "  --xtreme         (--quality 6.00)   excellent quality     (~ 210 kbps)\n"
              "\n"
 
@@ -326,6 +338,6 @@
              "  mppenc inputfile.wav\n"
              "  mppenc inputfile.wav outputfile.mpc\n"
-             "  mppenc --xtreme inputfile.pac outputfile.mpc\n"
-             "  mppenc --silent --radio inputfile.pac outputfile.mpc\n"
+             "  mppenc --xtreme inputfile.wav outputfile.mpc\n"
+             "  mppenc --silent --radio inputfile.wav outputfile.mpc\n"
              "\n"
              "For further information see the file 'MANUAL.TXT' or use option --longhelp.\n" );